#!/usr/local/bin/perl -w
#
#
#

$month = $ARGV[0]; 
$year = $ARGV[1]; 

$outfile = "$month$year.cgi";

open (OUTFILE,">$outfile") or die "can't open $outfile $! \n";

print OUTFILE<<EOF;
#!/usr/local/bin/perl -wT
# 
# 

use CGI qw(:standard);
use strict;
use File::Copy;
use Fcntl ":flock";

#
# -- get params from web form --
#

my \$in = param('dayin');
my \$out = param('dayout');
my \$name = param('name');
my \$room = param('room');
my \$func = param('do');
my \$bud = param('budget');

#
# -- define working files --
#

my \$calfile = "/afs/cern.ch/user/k/kennedyj/WWW/ATLAS-FLAT/$month-$year.html" ; 

#
# -- protect against leaving before arriving --
#

if (\$out < \$in ){
       print   header, start_html("Booking error"),h1("Booking error") ;
       print hr ;
       print p("You seem to be leaving the flat before you arrive") ;
       print p("Day in was \$in  -- But --  Day out was \$out");  
       print p("Please Try booking again with correct dates");  
       print hr;
exit;
}

#
# -- define the values input fields may take --
#

my \@namesarray = qw( JAK/Gla/ RLB/Gla/ KMS/Gla/ VOS/Gla/ GJM/Gla/ WHB/Gla/ DGC/Gla/ 
			AST/Gla/ PM/Gla/ MR/Gla/ PS/Gla/ AP/Gla/ CJP/Gla/ PD/Shf/
                        FD/Gla/ JGL/Gla/ JM/Gla/ StD/Gla/ APa/RAL/ AM/Gla/ ID/Shf/
		        ATC/Gla/ GP/Gla/ PR/Gla/ FQ/Gla/ );
my \@budarray = qw( AT ST AL LB ALI CM DD GR DP SAT );
my \@funcarray = qw (bookin free);
my \@roomarray = qw (1 2 3 4);
my \@numarray = qw (1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 
                   25 26 27 28 29 30 31 );

#
# -- check the input values (fields) --
#

&checkfields(\$name,\@namesarray);
&checkfields(\$room,\@roomarray);
&checkfields(\$bud,\@budarray);
&checkfields(\$func,\@funcarray);
&checkfields(\$in,\@numarray);
&checkfields(\$out,\@numarray);

#
# -- open input working file --
#

open(INFILE,"+>>\$calfile") || die print header, start_html("word"),h1("can't open \$calfile");
flock (INFILE,2) ;
seek (INFILE,0,0);

#
# -- read orig web page into string --
#

my \$str="" ;

while (<INFILE>) {
 \$str.=\$_;
}

#
# -- exec the substitue function --
#

my \$day = 0;
my \$sub = "\$name"."\$bud";
my \$bookingfailure = 0;

#
# -- loop over all the days --
#

for (\$day = \$in; \$day<=\$out; \$day++) {

if (\$func eq "bookin" ) {
    if (\$str =~ s/free(<!--\$day:\$room-->)/\$sub\${1}/sg ){
                \$bookingfailure = \$bookingfailure ;
        }else{
                \$bookingfailure = 1 ;
             }
 }elsif (\$func eq "free" ){ 

     if (\$str =~s/\$sub(<!--\$day:\$room-->)/free\${1}/sg ){
                \$bookingfailure = \$bookingfailure ;
        }else{
                \$bookingfailure = 1 ;
             }
 }
}

#
# -- seek, truncate and fill working file --
#
seek  (INFILE,0,0);
truncate \$calfile , 0;
print INFILE "\$str" ;
close INFILE;
#
# -- complain about failure to book a room --
#

if (\$bookingfailure == 1 ){
       print   header, start_html("Booking error"),h1("Booking error") ;
       print hr ;
       print p("One or more of your requests have failed") ;
       print p("All compatible bookings have been made");
       print p("Please reload the booking page and try again with correct fields");
       print p("Note: This may or may not cause a problem");
       print p("      You must study the bookings to see what went wrong");
       print p("If this problem persists contact the site manager");
       print hr;

       exit;
}


#
# -- reload web page --
#

my \$goto = "http://alephwww.cern.ch/~kennedyj/ATLAS-FLAT/$month-$year.html";
print "Location: \$goto \\n\\n";

#
# -- subroutine for checking field values --
#

sub checkfields {

# check the names of people
my (\$Tname, \@Tarray) = \@_;
my \$found = 0;
my \$itrname;

   foreach \$itrname (\@Tarray) {
        if ( \$Tname eq \$itrname ) {
        \$found = 1;
        last;
        }
   }

   if (\$found != 1){
       print   header, start_html("Booking error"),h1("Booking error") ;
       print hr ;
       print p("You seem to have a wrong field in your input") ;
       print p("Please Try booking again with correct fields");  
       print p("If this problem persists contact the site manager");
       print hr;

       exit;    
   }


}
exit;

EOF

close OUTFILE;
